#include <Math.au3>
#include <String.au3>
#include <Array.au3>
#include <Word.au3>

$fil = FileOpenDialog ("    ", @ScriptDir, "  (*.smw)", 1+4)
If @error Then My_Err("   -  " & @CRLF & @CRLF & "   ?")

$hFile = FileOpen($fil, 16)

$aArray = FileReadToArray($hFile)
if @error Then My_Err("  " & $fil)
$fil =  StringReplace($fil, ".smw", "_R.txt")

$tmp = StringSplit($aArray[0], ' ')
if $tmp[0] <> 5 Then My_Err("  " & @CRLF & @CRLF & "      5 ,    " & $tmp[0])
if $tmp[5] <> 0 Then My_Err("  " & @CRLF & @CRLF & "    013,  012!")

$N = $tmp[1] ;  
$Nt = $tmp[3] ;   
$tp = StringMid($aArray[$N+4],2,1) ;  0 - 0=1,  1 - ABCDEFGHIJK...
$Tname = StringStripWS(StringMid($aArray[$N+1],2,99), 2) ;   -     
$Aname = StringStripWS(StringMid($aArray[$N+9],2,99), 2) ;   -  

Local $Name[$N+1]   ; 
Local $Raz[$N+1]    ;   
Local $Town[$N+1]   ;   
Local $Mesto[$N+1]  ; 
Local $Num[$N+1]    ; -1 1- ,2-   ..
Local $Sum[$N+1]    ; 
Local $F[$N+1]      ;    
Local $Kb[$N+1]     ;  
Local $KbBH[$N+1]   ;  BH
Local $Zb[$N+1]     ;  -

For $i = 1 To $N ;  
   $Stmp = StringReplace( StringMid($aArray[$i],9,26), ",", " ") ;    
   $Stmp = StringStripWS($Stmp, 4+2) ;       . 26   
   $Stmp = StringSplit($Stmp, " ") ;    
   $Name[$i] = $Stmp[1]
   If $Stmp[0] > 1 Then $Name[$i] = $Stmp[1] & " " & $Stmp[2] ;  
   If $Stmp[0] > 2 Then $Raz[$i] = $Stmp[3]				;   
   If $Stmp[0] > 3 Then $Town[$i] = $Stmp[4]
   $Sum[$i] = 0
   $F[$i] = 0
Next
For $i = 1 To $N ;  
   For $j = 1 To $Nt
	  $tmp = StringMid($aArray[$i],60+$j*11,1) ;   
	  If $tp = 0 Then
		 If $tmp = '1' Then
			$Sum[$i] += 1
		 ElseIf $tmp = '' Then
			$Sum[$i] += 0.5
		 ElseIf $tmp <> '0' Then
			My_Err("   " & @CRLF & @CRLF & " 01,    " & $tmp)
		 EndIf
		 If StringMid($aArray[$i],59+$j*11,1) = '-' Then $F[$i] = 0.5
	  Else
         $Sum[$i] += (Asc($tmp) - Asc("A")) / 2
		 If StringMid($aArray[$i],59+$j*11,1) = '-' Then $F[$i] = (Asc($tmp) - Asc("A")) / 4
	  EndIf
   Next
   $Kb[$i] = 0
   $KbBH[$i] = 0
   $Zb[$i] = 0
Next
For $i = 1 To $N ;  
   $max = 0
   $min = 99999
   For $j = 1 To $Nt
	  If StringMid($aArray[$i],59+$j*11,1) = '-' Then ;  
		 $r3 = $Sum[$i] - $F[$i]
		 $Zb[$i] += $r3 / 2
	  Else
		 $tmp = StringMid($aArray[$i],62+$j*11,2) ;  
		 $r3 = $Sum[$tmp] - $F[$tmp] ;    
		 $r = Asc(StringMid($aArray[$i],60+$j*11,1))
		 $r2 = Asc(StringMid($aArray[$tmp],60+$j*11,1))
		 If $r > $r2 Then
			$Zb[$i] += $r3
		 ElseIf $r = $r2 Then
			$Zb[$i] += $r3 / 2
		 EndIf
	  EndIf
	  $Kb[$i] += $r3
	  If $max < $r3 Then $max = $r3
	  If $min > $r3 Then $min = $r3
   Next
   $KbBH[$i] = $Kb[$i] - $max - $min
   $Num[$i] = $i
Next

For $i = 1 To $N-1 ;   
   For $j = $i+1 To $N
	  If $Sum[$Num[$i]] < $Sum[$Num[$j]] Then
		 Swap($i, $j)
	  ElseIf $Sum[$Num[$i]] = $Sum[$Num[$j]] Then
		 If $Kb[$Num[$i]] < $Kb[$Num[$j]] Then
			Swap($i, $j)
		 ElseIf $Kb[$Num[$i]] = $Kb[$Num[$j]] Then
			If $Zb[$Num[$i]] < $Zb[$Num[$j]] Then
			   Swap($i, $j)
			ElseIf $Zb[$Num[$i]] = $Zb[$Num[$j]] Then
			   If $KbBH[$Num[$i]] < $KbBH[$Num[$j]] Then
				  Swap($i, $j)
			   ElseIf $KbBH[$Num[$i]] = $KbBH[$Num[$j]] Then
				  My_Err(" " & @CRLF & @CRLF & "    ")
			   EndIf
			EndIf
		 EndIf
	  EndIf
   Next
Next
For $i = 1 To $N ;  
   $Mesto[$Num[$i]] = $i
Next

;_ArrayDisplay($Mesto)
;Exit
;ConsoleWrite ( " All good! " & $fil & @CRLF)


;FileWriteLine($fil, @CRLF & "   " & $N & " " &  @CRLF)
;  
FileWrite($fil, "" & @TAB & "" & @TAB)
For $j = 1 To $Nt
   FileWrite($fil, "R" & $j & @TAB)
Next
FileWriteLine($fil, "" & @TAB & "" & @TAB & "" & @TAB & "")

For $i = 1 To $N ;  
   FileWrite($fil, $i & @TAB & $Name[$Num[$i]] & @TAB)
   For $j = 1 To $Nt ;    -    ( )  
	  If StringMid($aArray[$Num[$i]],59+$j*11,1) = '-' Then
		 FileWrite($fil, '+' & @TAB)
	  Else
;                                        -              W  B
		 FileWrite($fil, $Mesto[StringMid($aArray[$Num[$i]],62+$j*11,2)] & StringMid($aArray[$Num[$i]],59+$j*11,1))
		 $tmp = StringMid($aArray[$Num[$i]],60+$j*11,1) ;   
		 If $tp = 0 Then
			If $tmp = '' Then $tmp = 'S'
			FileWrite($fil, $tmp & @TAB)
		 Else
			FileWrite($fil, (Asc($tmp) - Asc("A")) / 2 & @TAB)
		 EndIf
	  EndIf
   Next
   FileWrite($fil, $Sum[$Num[$i]] & @TAB & $Kb[$Num[$i]] & @TAB & $Zb[$Num[$i]] & @TAB & $KbBH[$Num[$i]] & @CRLF) ;  
Next

;Exit

;  
$oWord = _Word_Create()       ;    Word
$oDoc =_Word_DocAdd($oWord)   ;     Word 
Const $WrdConst=2.835         ;   .    1      2.835

With $oDoc.PageSetup
   .PaperSize = 7                    ; wdPaperA4
   .Orientation = $WdOrientLandscape ;   -  :)
   .LeftMargin = 20*$WrdConst
   .RightMargin = 20*$WrdConst
   .TopMargin = 10*$WrdConst
   .BottomMargin = 1*$WrdConst
EndWith

$oDoc.Range.insertAfter (":" & @TAB & @MDAY & '.' & @MON & '.' & @YEAR & @TAB & @TAB & " " & @TAB & ":" & @TAB & @MDAY & '.' & @MON & '.' & @YEAR & @TAB & @CRLF)
If $Tname = '' Then
   $oDoc.Range.insertAfter ( "     !" )
Else
   $oDoc.Range.insertAfter ($Tname)
EndIf


;$oWord.Application.Selection.WholeStory
;$oWord.Application.Selection.ParagraphFormat.Alignment = 1
;$oDoc.Range.insertAfter (":" & @TAB & "666" & @TAB & @TAB & " " & @TAB & ":" & @TAB & "666" & @TAB & @CRLF)
;$oDoc.Range.insertAfter (":" & @TAB & "pipisko" & @TAB & @TAB & " " & @TAB & ":" & @TAB & "pipisko" & @TAB & @CRLF)

;$oDoc.Range.insertAfter ("")

;$oDoc.Words(2).Font.Size = 17
;$oDoc.Words(13).Select

;$oDoc.Paragraphs(1).Range.Font.Size = 30
;$oDoc.Paragraphs(1).Range.Format.Tabs.AddTab(10)

;$oDoc.Application.Selection.Paragraphs(1).ParagraphFormat.TabStops.AddPosition = 10


;Exit

Local $AAA[$N+2][7+$Nt] ;   .   1  -1   .
$AAA[1][0] = ""
$AAA[1][1] = ""
$AAA[1][2] = ""
$AAA[1][3] = ""
For $j = 1 To $Nt
   $AAA[1][3+$j] = "R"&$j
Next
$AAA[1][$Nt+4] = ""
$AAA[1][$Nt+5] = ""
$AAA[1][$Nt+6] = ""

For $i = 1 To $N ;-$N
   $AAA[1+$i][0] = $i  				;  
   $AAA[1+$i][1] = $Name[$Num[$i]]  ;  
   $AAA[1+$i][2] = $Town[$Num[$i]]  ;    
   $AAA[1+$i][3] = $Raz[$Num[$i]]   ;    

   For $j = 1 To $Nt ;    -    ( )  
  	  If StringMid($aArray[$Num[$i]],59+$j*11,1) = '-' Then
		 $r = '+'
	  Else
;                                        -              W  B
		 $r = $Mesto[StringMid($aArray[$Num[$i]],62+$j*11,2)] & StringMid($aArray[$Num[$i]],59+$j*11,1)
		 $tmp = StringMid($aArray[$Num[$i]],60+$j*11,1) ;   
		 If $tp = 0 Then
			If $tmp = '' Then $tmp = 'S'
			$r = $r & $tmp
		 Else
			$r = $r & (Asc($tmp) - Asc("A")) / 2
		 EndIf
	  EndIf
	  $AAA[1+$i][3+$j]  = $r
   Next
   $AAA[1+$i][$Nt+4] = $Sum[$Num[$i]]   ;    
   $AAA[1+$i][$Nt+5] =  $Kb[$Num[$i]]   ;  
   $AAA[1+$i][$Nt+6] =  $Zb[$Num[$i]]   ;  
Next

Local $oRange = _Word_DocRangeSet($oDoc, -2) ;     Word 

_Word_DocTableWrite($oRange, $AAA)
$oDoc.Tables(1).Style = " "    ;   
 ;      1 
With $oDoc.Tables.Item(1)
   .TopPadding = 0.1*$WrdConst;
   .BottomPadding = 0.1*$WrdConst;
   .RightPadding = 1*$WrdConst;
   .LeftPadding = 1*$WrdConst;
EndWith
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.SelectRow
$oWord.Application.Selection.SelectColumn
With $oWord.Application.Selection
   .Font.Name = 'Times New Roman'
   .Font.Size = 12
   .ParagraphFormat.Alignment = 1 ;   
   .Cells.VerticalAlignment = 1   ; wdAlignVerticalCenter
   .ParagraphFormat.SpaceBefore = 0
   .ParagraphFormat.SpaceBeforeAuto = False
   .ParagraphFormat.SpaceAfter = 0
   .ParagraphFormat.SpaceAfterAuto = False
   .ParagraphFormat.LineUnitBefore = 0
   .ParagraphFormat.LineUnitAfter = 0
   .Height=6*$WrdConst          ;    6 
   .Cells.Borders.OutsideLineStyle = 7 ;  
EndWith

$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,1,1) ; 1 2 
$oWord.Application.Selection.SelectColumn
$oWord.Application.Selection.Font.Bold = 1

$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.SelectColumn
$oWord.Application.Selection.Font.Size = 11

$oDoc.Tables.Item(1).Cell(1,5).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt-1,1) ; 
$oWord.Application.Selection.SelectColumn
$oWord.Application.Selection.Font.Size = 10
$WidthOfRez = 15 ;      -    11,   15
If $tp = 0 Then $WidthOfRez = 11
$oWord.Application.Selection.Cells.Width=$WidthOfRez*$WrdConst        ;     99w0  99w2.5

$oDoc.Tables.Item(1).Cell(1,$Nt+5).Select ;   
$oWord.Application.Selection.SelectColumn
$oWord.Application.Selection.Font.Bold = 1
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  

$oDoc.Tables.Item(1).Columns(1).Width=8*$WrdConst   ;  1-  8  - 
$oDoc.Tables.Item(1).Columns(2).Width=53*$WrdConst  ;  2-  53 

;  
$oDoc.Tables(1).Rows(1).Borders.OutsideLineStyle = 7            ;  

$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,3,1) ;    4 
$oWord.Application.Selection.MoveDown($wdLine,$N,1)        ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  

$oDoc.Tables(1).Borders.OutsideLineStyle = 7 ;  

$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.SelectRow
$oWord.Application.Selection.Font.Size = 12
$oWord.Application.Selection.Font.Bold = 0

$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+1,1)
$oWord.Application.Selection.Font.Size = 11
;
$oDoc.Range.insertAfter ("  ____________________" & @TAB & " ____________________")

$oWord.Selection.Tables(1).Rows.Alignment = 1

Exit

$oDoc.Tables.Item(1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 1 ;   
;Send("^e",0)
;ControlSend($oWord, "", "", "^e")

;$oDoc.Tables.Item(1).Range.ParagraphFormat.Alignment = 1

;$oDoc.Paragraphs(2).Select

$oDoc.Range.insertAfter ("This is some text to insert.")
$oDoc.Paragraphs(2).Range.Font.Bold = 1
$oDoc.Paragraphs(2).Range.Font.Size = 17

$oDoc.Paragraphs(17*20+1).Range.Font.Bold = 1
$oDoc.Paragraphs(17*20+2).Range.Font.Size = 17



Exit

$oDoc.Tables.Item(1).Select
$oWord.Application.Selection.Alignment = 2 ;   

$oWord.Application.Selection.WholeStory
$oWord.Application.Selection.ParagraphFormat.Alignment = 1
$oDoc.Range.insertAfter ("This is some text to insert.")


Exit


$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
;        -     
$oDoc.Tables.Item(1).Cell(1,1).Merge($oDoc.Tables.Item(1).Cell(1,6+$Nt))
$oDoc.Tables.Item(1).Cell(1,1).Split(1,3);
$oDoc.Tables(1).Cell(1,1).Range.Text = ": " & @MDAY & '.' & @MON & '.' & @YEAR
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 0 ;wdAlignParagraphLeft
$oDoc.Tables(1).Cell(1,3).Range.Text = ": " & @MDAY & '.' & @MON & '.' & @YEAR
$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 2 ;wdAlignParagraphRight
$oDoc.Tables(1).Cell(1,2).Range.Text = "                 "
If $Tname = '' Then
   $oDoc.Tables(1).Cell(2,1).Range.Text = "     !"
Else
   $oDoc.Tables(1).Cell(2,1).Range.Text = $Tname
EndIf
$oDoc.Tables(1).Cell(2,1).Range.Font.Bold = 1
$oDoc.Tables(1).Cell(2,1).Range.Font.Size = 16
$oDoc.Tables.Item(1).Cell(2,1).Merge($oDoc.Tables.Item(1).Cell(2,6+$Nt))
$oDoc.Tables.Item(1).Cell(4+$N,1).Merge($oDoc.Tables.Item(1).Cell(4+$N,6+$Nt))
$oDoc.Tables.Item(1).Cell(4+$N,1).Split(1,2);
$oDoc.Tables(1).Cell(4+$N,1).Range.Text = "  ____________________"
$oDoc.Tables.Item(1).Cell(4+$N,1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 0 ;wdAlignParagraphLeft
$oDoc.Tables(1).Cell(4+$N,2).Range.Text = " ____________________"
$oDoc.Tables.Item(1).Cell(4+$N,2).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 2 ;wdAlignParagraphRight


ConsoleWrite ( " All good! " & UBound($aArray) & @CRLF)

Exit



Func My_Err($OutText) ;    -    
    MsgBox(0, '!!  ', $OutText)
	Exit
EndFunc

Func Swap($i, $j)
   $kk = $Num[$i]
   $Num[$i] = $Num[$j]
   $Num[$j] = $kk
EndFunc
